/* Portions Copyright (c) 2005 Nokia Corporation */
#include "pgenheaders.h"
#include "grammar.h"

// XXX:CW32 added _all_ the casts here e.g (int*)

const static int accel_0_0[142] = {
0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00001d82, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 
0xffffffff, 0x00000981, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 0x00000981, 0x00000981, 0x00000981, 
0x00000981, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 
0x00000981, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00001d82, 0xffffffff, 0xffffffff, 0x00001d82, 0x00001d82, 
0x00001d82, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 
0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 
0x00000981, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00001d82, 
};

const static int accel_0_2[1] = {
0x00000001, 
};

const static int accel_1_0[142] = {
0x00000000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000001, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000880, 0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000880, 
0xffffffff, 0x00000880, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000880, 0x00000880, 0x00000880, 0x00000880, 0x00000880, 
0x00000880, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000880, 
0x00000880, 0xffffffff, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0x00000880, 0x00000880, 
0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000880, 0x00000880, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000880, 
0xffffffff, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0x00000880, 0x00000880, 
0x00000880, 0xffffffff, 0x00000880, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000880, 
};

const static int accel_2_0[126] = {
0x00003981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003981, 0x00003981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003981, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003981, 0xffffffff, 0xffffffff, 0x00003981, 
0xffffffff, 0xffffffff, 0x00003981, 0x00003981, 0x00003981, 0xffffffff, 0x00003981, 

};

const static int accel_2_1[6] = {
0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 
};

const static int accel_3_0[1] = {
0x00000001, 
};

const static int accel_3_1[1] = {
0x00000002, 
};

const static int accel_3_2[1] = {
0x00000483, 
};

const static int accel_3_3[1] = {
0x00000004, 
};

const static int accel_3_4[136] = {
0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002385, 
0xffffffff, 0x00002385, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002385, 0x00002385, 0x00002385, 0x00002385, 0x00002385, 
0x00002385, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002385, 
0x00002385, 0xffffffff, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002385, 0x00002385, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002385, 
0xffffffff, 0xffffffff, 0x00002385, 0xffffffff, 0xffffffff, 0x00002385, 0x00002385, 
0x00002385, 0xffffffff, 0x00002385, 
};

const static int accel_4_0[1] = {
0x00000001, 
};

const static int accel_4_1[13] = {
0x00000582, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000582, 0xffffffff, 0x00000003, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000582, 0x00000582, 
};

const static int accel_4_2[1] = {
0x00000003, 
};

const static int accel_5_0[13] = {
0x00000681, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000681, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 0x00000003, 
};

const static int accel_5_1[3] = {
0x00000004, 0xffffffff, 0x00000005, 
};

const static int accel_5_2[1] = {
0x00000006, 
};

const static int accel_5_3[1] = {
0x00000007, 
};

const static int accel_5_4[126] = {
0x00002488, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002488, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002488, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002488, 0x00002488, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002488, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002488, 0xffffffff, 0xffffffff, 0x00002488, 
0xffffffff, 0xffffffff, 0x00002488, 0x00002488, 0x00002488, 0xffffffff, 0x00002488, 

};

const static int accel_5_5[13] = {
0x00000681, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000681, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 0x00000003, 
};

const static int accel_5_6[1] = {
0x00000009, 
};

const static int accel_5_8[1] = {
0x00000005, 
};

const static int accel_5_9[1] = {
0x00000003, 
};

const static int accel_6_0[5] = {
0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 
};

const static int accel_6_2[5] = {
0x00000783, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000783, 
};

const static int accel_6_3[1] = {
0x00000001, 
};

const static int accel_7_0[5] = {
0x00000681, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000681, 
};

const static int accel_7_1[1] = {
0x00000002, 
};

const static int accel_7_2[5] = {
0x00000681, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000681, 
};

const static int accel_8_0[133] = {
0x00001d81, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0x00000981, 
0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000981, 0x00000981, 0x00000981, 0x00000981, 0x00000981, 0x00000981, 0xffffffff, 
0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 0xffffffff, 
0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00001d81, 0xffffffff, 0xffffffff, 0x00001d81, 0x00001d81, 0x00001d81, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000981, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 
0x00000981, 0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 0x00000981, 0xffffffff, 
0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00001d81, 

};

const static int accel_9_0[126] = {
0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0x00000a81, 0xffffffff, 
0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 
0x00000a81, 0x00000a81, 0x00000a81, 0x00000a81, 0x00000a81, 0xffffffff, 0x00000a81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0x00000a81, 0xffffffff, 0xffffffff, 
0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000a81, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0x00000a81, 
0xffffffff, 0xffffffff, 0x00000a81, 0x00000a81, 0x00000a81, 0xffffffff, 0x00000a81, 

};

const static int accel_9_1[26] = {
0x00000003, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 
};

const static int accel_9_2[136] = {
0x00000003, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 
0xffffffff, 0x00000a81, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000a81, 0x00000a81, 0x00000a81, 0x00000a81, 0x00000a81, 
0x00000a81, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 
0x00000a81, 0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 0x00000a81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000a81, 
0xffffffff, 0xffffffff, 0x00000a81, 0xffffffff, 0xffffffff, 0x00000a81, 0x00000a81, 
0x00000a81, 0xffffffff, 0x00000a81, 
};

const static int accel_10_0[126] = {
0x00000b81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000b81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000d81, 0xffffffff, 0x00000e81, 0xffffffff, 
0x00000f81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00001081, 
0x00001081, 0x00001081, 0x00001081, 0x00001081, 0x00001681, 0xffffffff, 0x00001681, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00001a81, 0x00001b81, 0xffffffff, 0xffffffff, 
0x00001c81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000b81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000b81, 0x00000b81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000b81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000b81, 0xffffffff, 0xffffffff, 0x00000b81, 
0xffffffff, 0xffffffff, 0x00000b81, 0x00000b81, 0x00000b81, 0xffffffff, 0x00000b81, 

};

const static int accel_11_0[126] = {
0x00003981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003981, 0x00003981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003981, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003981, 0xffffffff, 0xffffffff, 0x00003981, 
0xffffffff, 0xffffffff, 0x00003981, 0x00003981, 0x00003981, 0xffffffff, 0x00003981, 

};

const static int accel_11_1[30] = {
0x00000003, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000c82, 0x00000c82, 0x00000c82, 
0x00000c82, 0x00000c82, 0x00000c82, 0x00000c82, 0x00000c82, 0x00000c82, 0x00000c82, 
0x00000c82, 0x00000c82, 
};

const static int accel_11_2[126] = {
0x00003984, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003984, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003984, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003984, 0x00003984, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003984, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003984, 0xffffffff, 0xffffffff, 0x00003984, 
0xffffffff, 0xffffffff, 0x00003984, 0x00003984, 0x00003984, 0xffffffff, 0x00003984, 

};

const static int accel_11_3[126] = {
0x00003985, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003985, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003985, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003985, 0x00003985, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003985, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003985, 0xffffffff, 0xffffffff, 0x00003985, 
0xffffffff, 0xffffffff, 0x00003985, 0x00003985, 0x00003985, 0xffffffff, 0x00003985, 

};

const static int accel_11_5[1] = {
0x00000003, 
};

const static int accel_12_0[12] = {
0x00000001, 0x00000001, 0x00000001, 0x00000001, 0x00000001, 0x00000001, 0x00000001, 
0x00000001, 0x00000001, 0x00000001, 0x00000001, 0x00000001, 
};

const static int accel_13_0[1] = {
0x00000001, 
};

const static int accel_13_1[126] = {
0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000003, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002482, 0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 0x00002482, 
0xffffffff, 0xffffffff, 0x00002482, 0x00002482, 0x00002482, 0xffffffff, 0x00002482, 

};

const static int accel_13_2[1] = {
0x00000004, 
};

const static int accel_13_3[126] = {
0x00002485, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002485, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002485, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002485, 0x00002485, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002485, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002485, 0xffffffff, 0xffffffff, 0x00002485, 
0xffffffff, 0xffffffff, 0x00002485, 0x00002485, 0x00002485, 0xffffffff, 0x00002485, 

};

const static int accel_13_4[126] = {
0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002482, 0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 0x00002482, 
0xffffffff, 0xffffffff, 0x00002482, 0x00002482, 0x00002482, 0xffffffff, 0x00002482, 

};

const static int accel_13_5[1] = {
0x00000006, 
};

const static int accel_13_6[126] = {
0x00002487, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002487, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002487, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002487, 0x00002487, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002487, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002487, 0xffffffff, 0xffffffff, 0x00002487, 
0xffffffff, 0xffffffff, 0x00002487, 0x00002487, 0x00002487, 0xffffffff, 0x00002487, 

};

const static int accel_13_7[1] = {
0x00000008, 
};

const static int accel_14_0[1] = {
0x00000001, 
};

const static int accel_14_1[124] = {
0x00003882, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003882, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003882, 0x00003882, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003882, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003882, 0xffffffff, 0xffffffff, 0x00003882, 
0xffffffff, 0xffffffff, 0x00003882, 0x00003882, 0x00003882, 
};

const static int accel_15_0[1] = {
0x00000001, 
};

const static int accel_16_0[5] = {
0x00001181, 0x00001281, 0x00001381, 0x00001481, 0x00001581, 
};

const static int accel_17_0[1] = {
0x00000001, 
};

const static int accel_18_0[1] = {
0x00000001, 
};

const static int accel_19_0[1] = {
0x00000001, 
};

const static int accel_19_1[126] = {
0x00003982, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003982, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003982, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003982, 0x00003982, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003982, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003982, 0xffffffff, 0xffffffff, 0x00003982, 
0xffffffff, 0xffffffff, 0x00003982, 0x00003982, 0x00003982, 0xffffffff, 0x00003982, 

};

const static int accel_20_0[1] = {
0x00000001, 
};

const static int accel_21_0[1] = {
0x00000001, 
};

const static int accel_21_2[1] = {
0x00000003, 
};

const static int accel_21_3[126] = {
0x00002484, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002484, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002484, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002484, 0x00002484, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002484, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002484, 0xffffffff, 0xffffffff, 0x00002484, 
0xffffffff, 0xffffffff, 0x00002484, 0x00002484, 0x00002484, 0xffffffff, 0x00002484, 

};

const static int accel_21_4[1] = {
0x00000005, 
};

const static int accel_21_5[126] = {
0x00002486, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002486, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002486, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002486, 0x00002486, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002486, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002486, 0xffffffff, 0xffffffff, 0x00002486, 
0xffffffff, 0xffffffff, 0x00002486, 0x00002486, 0x00002486, 0xffffffff, 0x00002486, 

};

const static int accel_22_0[3] = {
0x00000001, 0xffffffff, 0x00000002, 
};

const static int accel_22_1[1] = {
0x00001883, 
};

const static int accel_22_2[1] = {
0x00001984, 
};

const static int accel_22_3[1] = {
0x00000001, 
};

const static int accel_22_4[1] = {
0x00000005, 
};

const static int accel_22_5[12] = {
0x00001787, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000006, 
};

const static int accel_22_7[1] = {
0x00000008, 
};

const static int accel_22_8[1] = {
0x00001787, 
};

const static int accel_23_0[1] = {
0x00000001, 
};

const static int accel_23_1[1] = {
0x00000002, 
};

const static int accel_23_2[1] = {
0x00000003, 
};

const static int accel_24_0[1] = {
0x00001981, 
};

const static int accel_24_1[1] = {
0x00000002, 
};

const static int accel_24_2[1] = {
0x00000003, 
};

const static int accel_25_0[1] = {
0x00000001, 
};

const static int accel_25_1[1] = {
0x00000000, 
};

const static int accel_26_0[1] = {
0x00000001, 
};

const static int accel_26_1[1] = {
0x00000002, 
};

const static int accel_26_2[1] = {
0x00000001, 
};

const static int accel_27_0[1] = {
0x00000001, 
};

const static int accel_27_1[124] = {
0x00002982, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002982, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002982, 0x00002982, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002982, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002982, 0xffffffff, 0xffffffff, 0x00002982, 
0xffffffff, 0xffffffff, 0x00002982, 0x00002982, 0x00002982, 
};

const static int accel_27_2[1] = {
0x00000003, 
};

const static int accel_27_4[1] = {
0x00000005, 
};

const static int accel_28_0[1] = {
0x00000001, 
};

const static int accel_28_2[1] = {
0x00000003, 
};

const static int accel_29_0[133] = {
0x00000381, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00001e81, 0xffffffff, 0xffffffff, 0x00001f81, 0x00002081, 0x00002181, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003c81, 

};

const static int accel_30_0[1] = {
0x00000001, 
};

const static int accel_30_2[1] = {
0x00000003, 
};

const static int accel_30_3[136] = {
0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002384, 
0xffffffff, 0x00002384, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002384, 0x00002384, 0x00002384, 0x00002384, 0x00002384, 
0x00002384, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002384, 
0x00002384, 0xffffffff, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002384, 0x00002384, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002384, 
0xffffffff, 0xffffffff, 0x00002384, 0xffffffff, 0xffffffff, 0x00002384, 0x00002384, 
0x00002384, 0xffffffff, 0x00002384, 
};

const static int accel_30_4[2] = {
0x00000001, 0x00000005, 
};

const static int accel_30_5[1] = {
0x00000006, 
};

const static int accel_30_6[136] = {
0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002387, 
0xffffffff, 0x00002387, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002387, 0x00002387, 0x00002387, 0x00002387, 0x00002387, 
0x00002387, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002387, 
0x00002387, 0xffffffff, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002387, 0x00002387, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002387, 
0xffffffff, 0xffffffff, 0x00002387, 0xffffffff, 0xffffffff, 0x00002387, 0x00002387, 
0x00002387, 0xffffffff, 0x00002387, 
};

const static int accel_31_0[1] = {
0x00000001, 
};

const static int accel_31_2[1] = {
0x00000003, 
};

const static int accel_31_4[1] = {
0x00000005, 
};

const static int accel_31_5[1] = {
0x00000006, 
};

const static int accel_32_0[1] = {
0x00000001, 
};

const static int accel_32_2[1] = {
0x00000003, 
};

const static int accel_32_4[1] = {
0x00000005, 
};

const static int accel_32_5[136] = {
0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002386, 
0xffffffff, 0x00002386, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002386, 0x00002386, 0x00002386, 0x00002386, 0x00002386, 
0x00002386, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002386, 
0x00002386, 0xffffffff, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002386, 0x00002386, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002386, 
0xffffffff, 0xffffffff, 0x00002386, 0xffffffff, 0xffffffff, 0x00002386, 0x00002386, 
0x00002386, 0xffffffff, 0x00002386, 
};

const static int accel_32_6[1] = {
0x00000007, 
};

const static int accel_32_7[1] = {
0x00000008, 
};

const static int accel_32_8[136] = {
0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002389, 
0xffffffff, 0x00002389, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002389, 0x00002389, 0x00002389, 0x00002389, 0x00002389, 
0x00002389, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002389, 
0x00002389, 0xffffffff, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002389, 0x00002389, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002389, 
0xffffffff, 0xffffffff, 0x00002389, 0xffffffff, 0xffffffff, 0x00002389, 0x00002389, 
0x00002389, 0xffffffff, 0x00002389, 
};

const static int accel_33_0[1] = {
0x00000001, 
};

const static int accel_33_1[1] = {
0x00000002, 
};

const static int accel_33_2[136] = {
0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002383, 
0xffffffff, 0x00002383, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002383, 0x00002383, 0x00002383, 0x00002383, 0x00002383, 
0x00002383, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002383, 
0x00002383, 0xffffffff, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002383, 0x00002383, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002383, 
0xffffffff, 0xffffffff, 0x00002383, 0xffffffff, 0xffffffff, 0x00002383, 0x00002383, 
0x00002383, 0xffffffff, 0x00002383, 
};

const static int accel_33_3[2] = {
0x00000005, 0x00002284, 
};

const static int accel_33_4[1] = {
0x00000006, 
};

const static int accel_33_5[1] = {
0x00000007, 
};

const static int accel_33_6[136] = {
0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002388, 
0xffffffff, 0x00002388, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002388, 0x00002388, 0x00002388, 0x00002388, 0x00002388, 
0x00002388, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002388, 
0x00002388, 0xffffffff, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002388, 0x00002388, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002388, 
0xffffffff, 0xffffffff, 0x00002388, 0xffffffff, 0xffffffff, 0x00002388, 0x00002388, 
0x00002388, 0xffffffff, 0x00002388, 
};

const static int accel_33_8[7] = {
0x00000005, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002284, 

};

const static int accel_34_0[1] = {
0x00000001, 
};

const static int accel_34_2[1] = {
0x00000003, 
};

const static int accel_35_0[136] = {
0x00000002, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 
0xffffffff, 0x00000981, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 0x00000981, 0x00000981, 0x00000981, 
0x00000981, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 
0x00000981, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000981, 
0xffffffff, 0xffffffff, 0x00000981, 0xffffffff, 0xffffffff, 0x00000981, 0x00000981, 
0x00000981, 0xffffffff, 0x00000981, 
};

const static int accel_35_2[1] = {
0x00000003, 
};

const static int accel_35_3[133] = {
0x00000884, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 0x00000884, 
0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000884, 0x00000884, 0x00000884, 0x00000884, 0x00000884, 0x00000884, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0x00000884, 0xffffffff, 
0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0x00000884, 0x00000884, 0x00000884, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000884, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0x00000884, 0x00000884, 0x00000884, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 

};

const static int accel_35_4[133] = {
0x00000884, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 0x00000884, 
0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000884, 0x00000884, 0x00000884, 0x00000884, 0x00000884, 0x00000884, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0x00000884, 0xffffffff, 
0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0x00000884, 0x00000884, 0x00000884, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000884, 0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 0xffffffff, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0x00000884, 0x00000884, 0x00000884, 0xffffffff, 
0x00000884, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000884, 

};

const static int accel_36_0[126] = {
0x00002581, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002581, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002581, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002581, 0x00002581, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002581, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002581, 0xffffffff, 0xffffffff, 0x00002581, 
0xffffffff, 0xffffffff, 0x00002581, 0x00002581, 0x00002581, 0xffffffff, 0x00003382, 

};

const static int accel_36_1[1] = {
0x00000003, 
};

const static int accel_36_3[124] = {
0x00002581, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002581, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002581, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002581, 0x00002581, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002581, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002581, 0xffffffff, 0xffffffff, 0x00002581, 
0xffffffff, 0xffffffff, 0x00002581, 0x00002581, 0x00002581, 
};

const static int accel_37_0[124] = {
0x00002681, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002681, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002681, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002681, 0x00002681, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002681, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002681, 0xffffffff, 0xffffffff, 0x00002681, 
0xffffffff, 0xffffffff, 0x00002681, 0x00002681, 0x00002681, 
};

const static int accel_37_1[1] = {
0x00000000, 
};

const static int accel_38_0[124] = {
0x00002782, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002782, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002782, 0x00002782, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002782, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002782, 0xffffffff, 0xffffffff, 0x00002782, 
0xffffffff, 0xffffffff, 0x00002782, 0x00002782, 0x00002782, 
};

const static int accel_38_1[124] = {
0x00002682, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002682, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002682, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002682, 0x00002682, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002682, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002682, 0xffffffff, 0xffffffff, 0x00002682, 
0xffffffff, 0xffffffff, 0x00002682, 0x00002682, 0x00002682, 
};

const static int accel_39_0[124] = {
0x00002981, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002981, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002981, 0x00002981, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002981, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002981, 0xffffffff, 0xffffffff, 0x00002981, 
0xffffffff, 0xffffffff, 0x00002981, 0x00002981, 0x00002981, 
};

const static int accel_39_1[34] = {
0x00002880, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00002880, 0xffffffff, 0xffffffff, 0x00002880, 0x00002880, 
0x00002880, 0x00002880, 0x00002880, 0x00002880, 0x00002880, 0x00002880, 
};

const static int accel_40_0[34] = {
0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000002, 0xffffffff, 0xffffffff, 0x00000001, 0x00000001, 
0x00000001, 0x00000001, 0x00000001, 0x00000001, 0x00000001, 0x00000003, 
};

const static int accel_40_2[1] = {
0x00000001, 
};

const static int accel_40_3[1] = {
0x00000001, 
};

const static int accel_41_0[124] = {
0x00002a81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002a81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002a81, 0x00002a81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002a81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002a81, 0xffffffff, 0xffffffff, 0x00002a81, 
0xffffffff, 0xffffffff, 0x00002a81, 0x00002a81, 0x00002a81, 
};

const static int accel_41_1[1] = {
0x00000000, 
};

const static int accel_42_0[124] = {
0x00002b81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002b81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002b81, 0x00002b81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002b81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002b81, 0xffffffff, 0xffffffff, 0x00002b81, 
0xffffffff, 0xffffffff, 0x00002b81, 0x00002b81, 0x00002b81, 
};

const static int accel_42_1[1] = {
0x00000000, 
};

const static int accel_43_0[124] = {
0x00002c81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002c81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002c81, 0x00002c81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002c81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002c81, 0xffffffff, 0xffffffff, 0x00002c81, 
0xffffffff, 0xffffffff, 0x00002c81, 0x00002c81, 0x00002c81, 
};

const static int accel_43_1[1] = {
0x00000000, 
};

const static int accel_44_0[124] = {
0x00002d81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002d81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002d81, 0x00002d81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002d81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002d81, 0xffffffff, 0xffffffff, 0x00002d81, 
0xffffffff, 0xffffffff, 0x00002d81, 0x00002d81, 0x00002d81, 
};

const static int accel_44_1[65] = {
0x00000000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000000, 
};

const static int accel_45_0[124] = {
0x00002e81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002e81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002e81, 0x00002e81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002e81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002e81, 0xffffffff, 0xffffffff, 0x00002e81, 
0xffffffff, 0xffffffff, 0x00002e81, 0x00002e81, 0x00002e81, 
};

const static int accel_45_1[2] = {
0x00000000, 0x00000000, 
};

const static int accel_46_0[124] = {
0x00002f81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002f81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002f81, 0x00002f81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002f81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002f81, 0xffffffff, 0xffffffff, 0x00002f81, 
0xffffffff, 0xffffffff, 0x00002f81, 0x00002f81, 0x00002f81, 
};

const static int accel_46_1[100] = {
0x00000000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 
0x00000000, 0x00000000, 
};

const static int accel_47_0[124] = {
0x00003082, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003082, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00000001, 0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000001, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003082, 0xffffffff, 0xffffffff, 0x00003082, 
0xffffffff, 0xffffffff, 0x00003082, 0x00003082, 0x00003082, 
};

const static int accel_47_1[124] = {
0x00002f82, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002f82, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002f82, 0x00002f82, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002f82, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002f82, 0xffffffff, 0xffffffff, 0x00002f82, 
0xffffffff, 0xffffffff, 0x00002f82, 0x00002f82, 0x00002f82, 
};

const static int accel_48_0[124] = {
0x00003181, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003181, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003181, 0xffffffff, 0xffffffff, 0x00003181, 
0xffffffff, 0xffffffff, 0x00003181, 0x00003181, 0x00003181, 
};

const static int accel_48_1[112] = {
0x00003481, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00000002, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003481, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003481, 

};

const static int accel_48_2[124] = {
0x00002f83, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002f83, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002f83, 0x00002f83, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002f83, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002f83, 0xffffffff, 0xffffffff, 0x00002f83, 
0xffffffff, 0xffffffff, 0x00002f83, 0x00002f83, 0x00002f83, 
};

const static int accel_48_3[1] = {
0x00000002, 
};

const static int accel_49_0[124] = {
0x00000005, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000001, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 0xffffffff, 0xffffffff, 0x00000003, 
0xffffffff, 0xffffffff, 0x00000004, 0x00000005, 0x00000006, 
};

const static int accel_49_1[126] = {
0x00003987, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003987, 0xffffffff, 0x00000005, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003987, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003987, 0x00003987, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003987, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003987, 0xffffffff, 0xffffffff, 0x00003987, 
0xffffffff, 0xffffffff, 0x00003987, 0x00003987, 0x00003987, 0xffffffff, 0x00003987, 

};

const static int accel_49_2[126] = {
0x00003288, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003288, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003288, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003288, 0x00003288, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003288, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003288, 0xffffffff, 0x00000005, 0x00003288, 
0xffffffff, 0xffffffff, 0x00003288, 0x00003288, 0x00003288, 0xffffffff, 0x00003288, 

};

const static int accel_49_3[126] = {
0x00003b89, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003b89, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003b89, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003b89, 0x00003b89, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003b89, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003b89, 0xffffffff, 0xffffffff, 0x00003b89, 
0xffffffff, 0x00000005, 0x00003b89, 0x00003b89, 0x00003b89, 0xffffffff, 0x00003b89, 

};

const static int accel_49_4[126] = {
0x0000398a, 0xffffffff, 0xffffffff, 0xffffffff, 0x0000398a, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x0000398a, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x0000398a, 0x0000398a, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x0000398a, 
0xffffffff, 0xffffffff, 0xffffffff, 0x0000398a, 0xffffffff, 0xffffffff, 0x0000398a, 
0xffffffff, 0xffffffff, 0x0000398a, 0x0000398a, 0x0000398a, 0xffffffff, 0x0000398a, 

};

const static int accel_49_6[1] = {
0x00000006, 
};

const static int accel_49_7[1] = {
0x00000005, 
};

const static int accel_49_8[1] = {
0x00000005, 
};

const static int accel_49_9[1] = {
0x00000005, 
};

const static int accel_49_10[1] = {
0x00000005, 
};

const static int accel_50_0[126] = {
0x00002481, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002481, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002481, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002481, 0x00002481, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002481, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002481, 0xffffffff, 0xffffffff, 0x00002481, 
0xffffffff, 0xffffffff, 0x00002481, 0x00002481, 0x00002481, 0xffffffff, 0x00002481, 

};

const static int accel_50_1[64] = {
0x00000003, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00004082, 
};

const static int accel_50_4[1] = {
0x00000003, 
};

const static int accel_51_0[1] = {
0x00000001, 
};

const static int accel_51_1[13] = {
0x00000582, 0xffffffff, 0x00000003, 0xffffffff, 0x00000582, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000582, 0x00000582, 
};

const static int accel_51_2[1] = {
0x00000003, 
};

const static int accel_52_0[112] = {
0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000003, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 

};

const static int accel_52_1[126] = {
0x00003d84, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003d84, 0xffffffff, 0x00000005, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003d84, 0x00003d84, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003d84, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003d84, 0x00003d84, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003d84, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003d84, 0xffffffff, 0xffffffff, 0x00003d84, 
0xffffffff, 0xffffffff, 0x00003d84, 0x00003d84, 0x00003d84, 0xffffffff, 0x00003d84, 

};

const static int accel_52_2[126] = {
0x00003586, 0xffffffff, 0x00003586, 0xffffffff, 0x00003586, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00003586, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003586, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003586, 0x00003586, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003586, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003586, 0xffffffff, 0xffffffff, 0x00003586, 
0xffffffff, 0xffffffff, 0x00003586, 0x00003586, 0x00003586, 0xffffffff, 0x00003586, 

};

const static int accel_52_3[1] = {
0x00000005, 
};

const static int accel_52_4[1] = {
0x00000005, 
};

const static int accel_52_6[1] = {
0x00000005, 
};

const static int accel_53_0[126] = {
0x00003681, 0xffffffff, 0x00003681, 0xffffffff, 0x00003681, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00003681, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003681, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003681, 0x00003681, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003681, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003681, 0xffffffff, 0xffffffff, 0x00003681, 
0xffffffff, 0xffffffff, 0x00003681, 0x00003681, 0x00003681, 0xffffffff, 0x00003681, 

};

const static int accel_53_1[1] = {
0x00000002, 
};

const static int accel_54_0[126] = {
0x00002482, 0xffffffff, 0x00000003, 0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0x00000001, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002482, 0x00002482, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002482, 0xffffffff, 0xffffffff, 0x00002482, 
0xffffffff, 0xffffffff, 0x00002482, 0x00002482, 0x00002482, 0xffffffff, 0x00002482, 

};

const static int accel_54_1[1] = {
0x00000004, 
};

const static int accel_54_2[1] = {
0x00000003, 
};

const static int accel_54_3[126] = {
0x00002485, 0xffffffff, 0x00003786, 0xffffffff, 0x00002485, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002485, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002485, 0x00002485, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002485, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002485, 0xffffffff, 0xffffffff, 0x00002485, 
0xffffffff, 0xffffffff, 0x00002485, 0x00002485, 0x00002485, 0xffffffff, 0x00002485, 

};

const static int accel_54_4[1] = {
0x00000006, 
};

const static int accel_54_5[1] = {
0x00003786, 
};

const static int accel_55_0[1] = {
0x00000001, 
};

const static int accel_56_1[1] = {
0x00000002, 
};

const static int accel_57_1[1] = {
0x00000002, 
};

const static int accel_58_1[1] = {
0x00000002, 
};

const static int accel_58_2[126] = {
0x00002483, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002483, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00002483, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00002483, 0x00002483, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00002483, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00002483, 0xffffffff, 0xffffffff, 0x00002483, 
0xffffffff, 0xffffffff, 0x00002483, 0x00002483, 0x00002483, 0xffffffff, 0x00002483, 

};

const static int accel_58_3[1] = {
0x00000004, 
};

const static int accel_59_1[1] = {
0x00000002, 
};

const static int accel_59_3[1] = {
0x00000004, 
};

const static int accel_60_0[1] = {
0x00000001, 
};

const static int accel_60_1[1] = {
0x00000002, 
};

const static int accel_60_2[3] = {
0x00000004, 0xffffffff, 0x00000003, 
};

const static int accel_60_5[1] = {
0x00000007, 
};

const static int accel_60_7[1] = {
0x00000004, 
};

const static int accel_61_0[126] = {
0x00003e81, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003e81, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00000002, 0x00000003, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003e81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003e81, 0x00003e81, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003e81, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003e81, 0xffffffff, 0xffffffff, 0x00003e81, 
0xffffffff, 0xffffffff, 0x00003e81, 0x00003e81, 0x00003e81, 0xffffffff, 0x00003e81, 

};

const static int accel_61_1[1] = {
0x00000004, 
};

const static int accel_61_5[1] = {
0x00000007, 
};

const static int accel_61_7[1] = {
0x00000003, 
};

const static int accel_62_1[1] = {
0x00000002, 
};

const static int accel_63_0[5] = {
0x00004181, 0xffffffff, 0xffffffff, 0xffffffff, 0x00004081, 
};

const static int accel_64_0[1] = {
0x00000001, 
};

const static int accel_64_2[1] = {
0x00000003, 
};

const static int accel_64_3[126] = {
0x00003a84, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003a84, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0x00003a84, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0x00003a84, 0x00003a84, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003a84, 
0xffffffff, 0xffffffff, 0xffffffff, 0x00003a84, 0xffffffff, 0xffffffff, 0x00003a84, 
0xffffffff, 0xffffffff, 0x00003a84, 0x00003a84, 0x00003a84, 0xffffffff, 0x00003a84, 
};

const static int accel_64_4[5] = {
0x00003f85, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003f85, 
};

const static int accel_65_0[1] = {
0x00000001, 
};

const static int accel_65_2[5] = {
0x00003f83, 0xffffffff, 0xffffffff, 0xffffffff, 0x00003f83, 
};



const static arc arcs_0_0[3] = {
	{2, 1},
	{3, 1},
	{4, 2},
};
const static arc arcs_0_1[1] = {
	{0, 1},
};
const static arc arcs_0_2[1] = {
	{2, 1},
};
const static state states_0[3] = {
	{3, (arc*)arcs_0_0, 2, 144, (int*)accel_0_0, 0},
	{1, (arc*)arcs_0_1, 0, 0, 0, 1},
	{1, (arc*)arcs_0_2, 2, 3, (int*)accel_0_2, 0},
};
const static arc arcs_1_0[3] = {
	{2, 0},
	{6, 0},
	{7, 1},
};
const static arc arcs_1_1[1] = {
	{0, 1},
};
const static state states_1[2] = {
	{3, (arc*)arcs_1_0, 2, 144, (int*)accel_1_0, 0},
	{1, (arc*)arcs_1_1, 0, 0, 0, 1},
};
const static arc arcs_2_0[1] = {
	{9, 1},
};
const static arc arcs_2_1[2] = {
	{2, 1},
	{7, 2},
};
const static arc arcs_2_2[1] = {
	{0, 2},
};
const static state states_2[3] = {
	{1, (arc*)arcs_2_0, 12, 138, (int*)accel_2_0, 0},
	{2, (arc*)arcs_2_1, 2, 8, (int*)accel_2_1, 0},
	{1, (arc*)arcs_2_2, 0, 0, 0, 1},
};
const static arc arcs_3_0[1] = {
	{11, 1},
};
const static arc arcs_3_1[1] = {
	{12, 2},
};
const static arc arcs_3_2[1] = {
	{13, 3},
};
const static arc arcs_3_3[1] = {
	{14, 4},
};
const static arc arcs_3_4[1] = {
	{15, 5},
};
const static arc arcs_3_5[1] = {
	{0, 5},
};
const static state states_3[6] = {
	{1, (arc*)arcs_3_0, 11, 12, (int*)accel_3_0, 0},
	{1, (arc*)arcs_3_1, 12, 13, (int*)accel_3_1, 0},
	{1, (arc*)arcs_3_2, 16, 17, (int*)accel_3_2, 0},
	{1, (arc*)arcs_3_3, 14, 15, (int*)accel_3_3, 0},
	{1, (arc*)arcs_3_4, 2, 138, (int*)accel_3_4, 0},
	{1, (arc*)arcs_3_5, 0, 0, 0, 1},
};
const static arc arcs_4_0[1] = {
	{16, 1},
};
const static arc arcs_4_1[2] = {
	{17, 2},
	{18, 3},
};
const static arc arcs_4_2[1] = {
	{18, 3},
};
const static arc arcs_4_3[1] = {
	{0, 3},
};
const static state states_4[4] = {
	{1, (arc*)arcs_4_0, 16, 17, (int*)accel_4_0, 0},
	{2, (arc*)arcs_4_1, 12, 25, (int*)accel_4_1, 0},
	{1, (arc*)arcs_4_2, 18, 19, (int*)accel_4_2, 0},
	{1, (arc*)arcs_4_3, 0, 0, 0, 1},
};
const static arc arcs_5_0[3] = {
	{19, 1},
	{23, 2},
	{24, 3},
};
const static arc arcs_5_1[3] = {
	{20, 4},
	{22, 5},
	{0, 1},
};
const static arc arcs_5_2[1] = {
	{12, 6},
};
const static arc arcs_5_3[1] = {
	{12, 7},
};
const static arc arcs_5_4[1] = {
	{21, 8},
};
const static arc arcs_5_5[4] = {
	{19, 1},
	{23, 2},
	{24, 3},
	{0, 5},
};
const static arc arcs_5_6[2] = {
	{22, 9},
	{0, 6},
};
const static arc arcs_5_7[1] = {
	{0, 7},
};
const static arc arcs_5_8[2] = {
	{22, 5},
	{0, 8},
};
const static arc arcs_5_9[1] = {
	{24, 3},
};
const static state states_5[10] = {
	{3, (arc*)arcs_5_0, 12, 25, (int*)accel_5_0, 0},
	{3, (arc*)arcs_5_1, 20, 23, (int*)accel_5_1, 1},
	{1, (arc*)arcs_5_2, 12, 13, (int*)accel_5_2, 0},
	{1, (arc*)arcs_5_3, 12, 13, (int*)accel_5_3, 0},
	{1, (arc*)arcs_5_4, 12, 138, (int*)accel_5_4, 0},
	{4, (arc*)arcs_5_5, 12, 25, (int*)accel_5_5, 1},
	{2, (arc*)arcs_5_6, 22, 23, (int*)accel_5_6, 1},
	{1, (arc*)arcs_5_7, 0, 0, 0, 1},
	{2, (arc*)arcs_5_8, 22, 23, (int*)accel_5_8, 1},
	{1, (arc*)arcs_5_9, 24, 25, (int*)accel_5_9, 0},
};
const static arc arcs_6_0[2] = {
	{12, 1},
	{16, 2},
};
const static arc arcs_6_1[1] = {
	{0, 1},
};
const static arc arcs_6_2[1] = {
	{25, 3},
};
const static arc arcs_6_3[1] = {
	{18, 1},
};
const static state states_6[4] = {
	{2, (arc*)arcs_6_0, 12, 17, (int*)accel_6_0, 0},
	{1, (arc*)arcs_6_1, 0, 0, 0, 1},
	{1, (arc*)arcs_6_2, 12, 17, (int*)accel_6_2, 0},
	{1, (arc*)arcs_6_3, 18, 19, (int*)accel_6_3, 0},
};
const static arc arcs_7_0[1] = {
	{19, 1},
};
const static arc arcs_7_1[2] = {
	{22, 2},
	{0, 1},
};
const static arc arcs_7_2[2] = {
	{19, 1},
	{0, 2},
};
const static state states_7[3] = {
	{1, (arc*)arcs_7_0, 12, 17, (int*)accel_7_0, 0},
	{2, (arc*)arcs_7_1, 22, 23, (int*)accel_7_1, 1},
	{2, (arc*)arcs_7_2, 12, 17, (int*)accel_7_2, 1},
};
const static arc arcs_8_0[2] = {
	{3, 1},
	{4, 1},
};
const static arc arcs_8_1[1] = {
	{0, 1},
};
const static state states_8[2] = {
	{2, (arc*)arcs_8_0, 11, 144, (int*)accel_8_0, 0},
	{1, (arc*)arcs_8_1, 0, 0, 0, 1},
};
const static arc arcs_9_0[1] = {
	{26, 1},
};
const static arc arcs_9_1[2] = {
	{27, 2},
	{2, 3},
};
const static arc arcs_9_2[2] = {
	{26, 1},
	{2, 3},
};
const static arc arcs_9_3[1] = {
	{0, 3},
};
const static state states_9[4] = {
	{1, (arc*)arcs_9_0, 12, 138, (int*)accel_9_0, 0},
	{2, (arc*)arcs_9_1, 2, 28, (int*)accel_9_1, 0},
	{2, (arc*)arcs_9_2, 2, 138, (int*)accel_9_2, 0},
	{1, (arc*)arcs_9_3, 0, 0, 0, 1},
};
const static arc arcs_10_0[9] = {
	{28, 1},
	{29, 1},
	{30, 1},
	{31, 1},
	{32, 1},
	{33, 1},
	{34, 1},
	{35, 1},
	{36, 1},
};
const static arc arcs_10_1[1] = {
	{0, 1},
};
const static state states_10[2] = {
	{9, (arc*)arcs_10_0, 12, 138, (int*)accel_10_0, 0},
	{1, (arc*)arcs_10_1, 0, 0, 0, 1},
};
const static arc arcs_11_0[1] = {
	{9, 1},
};
const static arc arcs_11_1[3] = {
	{37, 2},
	{20, 3},
	{0, 1},
};
const static arc arcs_11_2[1] = {
	{9, 4},
};
const static arc arcs_11_3[1] = {
	{9, 5},
};
const static arc arcs_11_4[1] = {
	{0, 4},
};
const static arc arcs_11_5[2] = {
	{20, 3},
	{0, 5},
};
const static state states_11[6] = {
	{1, (arc*)arcs_11_0, 12, 138, (int*)accel_11_0, 0},
	{3, (arc*)arcs_11_1, 20, 50, (int*)accel_11_1, 1},
	{1, (arc*)arcs_11_2, 12, 138, (int*)accel_11_2, 0},
	{1, (arc*)arcs_11_3, 12, 138, (int*)accel_11_3, 0},
	{1, (arc*)arcs_11_4, 0, 0, 0, 1},
	{2, (arc*)arcs_11_5, 20, 21, (int*)accel_11_5, 1},
};
const static arc arcs_12_0[12] = {
	{38, 1},
	{39, 1},
	{40, 1},
	{41, 1},
	{42, 1},
	{43, 1},
	{44, 1},
	{45, 1},
	{46, 1},
	{47, 1},
	{48, 1},
	{49, 1},
};
const static arc arcs_12_1[1] = {
	{0, 1},
};
const static state states_12[2] = {
	{12, (arc*)arcs_12_0, 38, 50, (int*)accel_12_0, 0},
	{1, (arc*)arcs_12_1, 0, 0, 0, 1},
};
const static arc arcs_13_0[1] = {
	{50, 1},
};
const static arc arcs_13_1[3] = {
	{21, 2},
	{51, 3},
	{0, 1},
};
const static arc arcs_13_2[2] = {
	{22, 4},
	{0, 2},
};
const static arc arcs_13_3[1] = {
	{21, 5},
};
const static arc arcs_13_4[2] = {
	{21, 2},
	{0, 4},
};
const static arc arcs_13_5[2] = {
	{22, 6},
	{0, 5},
};
const static arc arcs_13_6[1] = {
	{21, 7},
};
const static arc arcs_13_7[2] = {
	{22, 8},
	{0, 7},
};
const static arc arcs_13_8[2] = {
	{21, 7},
	{0, 8},
};
const static state states_13[9] = {
	{1, (arc*)arcs_13_0, 50, 51, (int*)accel_13_0, 0},
	{3, (arc*)arcs_13_1, 12, 138, (int*)accel_13_1, 1},
	{2, (arc*)arcs_13_2, 22, 23, (int*)accel_13_2, 1},
	{1, (arc*)arcs_13_3, 12, 138, (int*)accel_13_3, 0},
	{2, (arc*)arcs_13_4, 12, 138, (int*)accel_13_4, 1},
	{2, (arc*)arcs_13_5, 22, 23, (int*)accel_13_5, 1},
	{1, (arc*)arcs_13_6, 12, 138, (int*)accel_13_6, 0},
	{2, (arc*)arcs_13_7, 22, 23, (int*)accel_13_7, 1},
	{2, (arc*)arcs_13_8, 12, 138, (int*)accel_13_6, 1},    /* optimize! */
};
const static arc arcs_14_0[1] = {
	{52, 1},
};
const static arc arcs_14_1[1] = {
	{53, 2},
};
const static arc arcs_14_2[1] = {
	{0, 2},
};
const static state states_14[3] = {
	{1, (arc*)arcs_14_0, 52, 53, (int*)accel_14_0, 0},
	{1, (arc*)arcs_14_1, 12, 136, (int*)accel_14_1, 0},
	{1, (arc*)arcs_14_2, 0, 0, 0, 1},
};
const static arc arcs_15_0[1] = {
	{54, 1},
};
const static arc arcs_15_1[1] = {
	{0, 1},
};
const static state states_15[2] = {
	{1, (arc*)arcs_15_0, 54, 55, (int*)accel_15_0, 0},
	{1, (arc*)arcs_15_1, 0, 0, 0, 1},
};
const static arc arcs_16_0[5] = {
	{55, 1},
	{56, 1},
	{57, 1},
	{58, 1},
	{59, 1},
};
const static arc arcs_16_1[1] = {
	{0, 1},
};
const static state states_16[2] = {
	{5, (arc*)arcs_16_0, 60, 65, (int*)accel_16_0, 0},
	{1, (arc*)arcs_16_1, 0, 0, 0, 1},
};
const static arc arcs_17_0[1] = {
	{60, 1},
};
const static arc arcs_17_1[1] = {
	{0, 1},
};
const static state states_17[2] = {
	{1, (arc*)arcs_17_0, 60, 61, (int*)accel_17_0, 0},
	{1, (arc*)arcs_17_1, 0, 0, 0, 1},
};
const static arc arcs_18_0[1] = {
	{61, 1},
};
const static arc arcs_18_1[1] = {
	{0, 1},
};
const static state states_18[2] = {
	{1, (arc*)arcs_18_0, 61, 62, (int*)accel_18_0, 0},
	{1, (arc*)arcs_18_1, 0, 0, 0, 1},
};
const static arc arcs_19_0[1] = {
	{62, 1},
};
const static arc arcs_19_1[2] = {
	{9, 2},
	{0, 1},
};
const static arc arcs_19_2[1] = {
	{0, 2},
};
const static state states_19[3] = {
	{1, (arc*)arcs_19_0, 62, 63, (int*)accel_19_0, 0},
	{2, (arc*)arcs_19_1, 12, 138, (int*)accel_19_1, 1},
	{1, (arc*)arcs_19_2, 0, 0, 0, 1},
};
const static arc arcs_20_0[1] = {
	{63, 1},
};
const static arc arcs_20_1[1] = {
	{9, 2},
};
const static arc arcs_20_2[1] = {
	{0, 2},
};
const static state states_20[3] = {
	{1, (arc*)arcs_20_0, 63, 64, (int*)accel_20_0, 0},
	{1, (arc*)arcs_20_1, 12, 138, (int*)accel_19_1, 0},    /*  optimize! */
	{1, (arc*)arcs_20_2, 0, 0, 0, 1},
};
const static arc arcs_21_0[1] = {
	{64, 1},
};
const static arc arcs_21_1[2] = {
	{21, 2},
	{0, 1},
};
const static arc arcs_21_2[2] = {
	{22, 3},
	{0, 2},
};
const static arc arcs_21_3[1] = {
	{21, 4},
};
const static arc arcs_21_4[2] = {
	{22, 5},
	{0, 4},
};
const static arc arcs_21_5[1] = {
	{21, 6},
};
const static arc arcs_21_6[1] = {
	{0, 6},
};
const static state states_21[7] = {
	{1, (arc*)arcs_21_0, 64, 65, (int*)accel_21_0, 0},
	{2, (arc*)arcs_21_1, 12, 138, (int*)accel_13_4, 1},    /*  optimize! */
	{2, (arc*)arcs_21_2, 22, 23, (int*)accel_21_2, 1},
	{1, (arc*)arcs_21_3, 12, 138, (int*)accel_21_3, 0},
	{2, (arc*)arcs_21_4, 22, 23, (int*)accel_21_4, 1},
	{1, (arc*)arcs_21_5, 12, 138, (int*)accel_21_5, 0},
	{1, (arc*)arcs_21_6, 0, 0, 0, 1},
};
const static arc arcs_22_0[2] = {
	{65, 1},
	{67, 2},
};
const static arc arcs_22_1[1] = {
	{66, 3},
};
const static arc arcs_22_2[1] = {
	{68, 4},
};
const static arc arcs_22_3[2] = {
	{22, 1},
	{0, 3},
};
const static arc arcs_22_4[1] = {
	{65, 5},
};
const static arc arcs_22_5[2] = {
	{23, 6},
	{69, 7},
};
const static arc arcs_22_6[1] = {
	{0, 6},
};
const static arc arcs_22_7[2] = {
	{22, 8},
	{0, 7},
};
const static arc arcs_22_8[1] = {
	{69, 7},
};
const static state states_22[9] = {
	{2, (arc*)arcs_22_0, 65, 68, (int*)accel_22_0, 0},
	{1, (arc*)arcs_22_1, 12, 13, (int*)accel_22_1, 0},
	{1, (arc*)arcs_22_2, 12, 13, (int*)accel_22_2, 0},
	{2, (arc*)arcs_22_3, 22, 23, (int*)accel_22_3, 1},
	{1, (arc*)arcs_22_4, 65, 66, (int*)accel_22_4, 0},
	{2, (arc*)arcs_22_5, 12, 24, (int*)accel_22_5, 0},
	{1, (arc*)arcs_22_6, 0, 0, 0, 1},
	{2, (arc*)arcs_22_7, 22, 23, (int*)accel_22_7, 1},
	{1, (arc*)arcs_22_8, 12, 13, (int*)accel_22_8, 0},
};
const static arc arcs_23_0[1] = {
	{12, 1},
};
const static arc arcs_23_1[2] = {
	{12, 2},
	{0, 1},
};
const static arc arcs_23_2[1] = {
	{12, 3},
};
const static arc arcs_23_3[1] = {
	{0, 3},
};
const static state states_23[4] = {
	{1, (arc*)arcs_23_0, 12, 13, (int*)accel_23_0, 0},
	{2, (arc*)arcs_23_1, 12, 13, (int*)accel_23_1, 1},
	{1, (arc*)arcs_23_2, 12, 13, (int*)accel_23_2, 0},
	{1, (arc*)arcs_23_3, 0, 0, 0, 1},
};
const static arc arcs_24_0[1] = {
	{68, 1},
};
const static arc arcs_24_1[2] = {
	{12, 2},
	{0, 1},
};
const static arc arcs_24_2[1] = {
	{12, 3},
};
const static arc arcs_24_3[1] = {
	{0, 3},
};
const static state states_24[4] = {
	{1, (arc*)arcs_24_0, 12, 13, (int*)accel_24_0, 0},
	{2, (arc*)arcs_24_1, 12, 13, (int*)accel_24_1, 1},
	{1, (arc*)arcs_24_2, 12, 13, (int*)accel_24_2, 0},
	{1, (arc*)arcs_24_3, 0, 0, 0, 1},
};
const static arc arcs_25_0[1] = {
	{12, 1},
};
const static arc arcs_25_1[2] = {
	{70, 0},
	{0, 1},
};
const static state states_25[2] = {
	{1, (arc*)arcs_25_0, 12, 13, (int*)accel_25_0, 0},
	{2, (arc*)arcs_25_1, 70, 71, (int*)accel_25_1, 1},
};
const static arc arcs_26_0[1] = {
	{71, 1},
};
const static arc arcs_26_1[1] = {
	{12, 2},
};
const static arc arcs_26_2[2] = {
	{22, 1},
	{0, 2},
};
const static state states_26[3] = {
	{1, (arc*)arcs_26_0, 71, 72, (int*)accel_26_0, 0},
	{1, (arc*)arcs_26_1, 12, 13, (int*)accel_26_1, 0},
	{2, (arc*)arcs_26_2, 22, 23, (int*)accel_26_2, 1},
};
const static arc arcs_27_0[1] = {
	{72, 1},
};
const static arc arcs_27_1[1] = {
	{73, 2},
};
const static arc arcs_27_2[2] = {
	{74, 3},
	{0, 2},
};
const static arc arcs_27_3[1] = {
	{21, 4},
};
const static arc arcs_27_4[2] = {
	{22, 5},
	{0, 4},
};
const static arc arcs_27_5[1] = {
	{21, 6},
};
const static arc arcs_27_6[1] = {
	{0, 6},
};
const static state states_27[7] = {
	{1, (arc*)arcs_27_0, 72, 73, (int*)accel_27_0, 0},
	{1, (arc*)arcs_27_1, 12, 136, (int*)accel_27_1, 0},
	{2, (arc*)arcs_27_2, 74, 75, (int*)accel_27_2, 1},
	{1, (arc*)arcs_27_3, 12, 138, (int*)accel_21_3, 0},    /*  optimize! */
	{2, (arc*)arcs_27_4, 22, 23, (int*)accel_27_4, 1},
	{1, (arc*)arcs_27_5, 12, 138, (int*)accel_21_5, 0},    /*  optimize! */
	{1, (arc*)arcs_27_6, 0, 0, 0, 1},
};
const static arc arcs_28_0[1] = {
	{75, 1},
};
const static arc arcs_28_1[1] = {
	{21, 2},
};
const static arc arcs_28_2[2] = {
	{22, 3},
	{0, 2},
};
const static arc arcs_28_3[1] = {
	{21, 4},
};
const static arc arcs_28_4[1] = {
	{0, 4},
};
const static state states_28[5] = {
	{1, (arc*)arcs_28_0, 75, 76, (int*)accel_28_0, 0},
	{1, (arc*)arcs_28_1, 12, 138, (int*)accel_13_4, 0},    /*  optimize! */
	{2, (arc*)arcs_28_2, 22, 23, (int*)accel_28_2, 1},
	{1, (arc*)arcs_28_3, 12, 138, (int*)accel_21_3, 0},    /*  optimize! */
	{1, (arc*)arcs_28_4, 0, 0, 0, 1},
};
const static arc arcs_29_0[6] = {
	{76, 1},
	{77, 1},
	{78, 1},
	{79, 1},
	{10, 1},
	{80, 1},
};
const static arc arcs_29_1[1] = {
	{0, 1},
};
const static state states_29[2] = {
	{6, (arc*)arcs_29_0, 11, 144, (int*)accel_29_0, 0},
	{1, (arc*)arcs_29_1, 0, 0, 0, 1},
};
const static arc arcs_30_0[1] = {
	{81, 1},
};
const static arc arcs_30_1[1] = {
	{21, 2},
};
const static arc arcs_30_2[1] = {
	{14, 3},
};
const static arc arcs_30_3[1] = {
	{15, 4},
};
const static arc arcs_30_4[3] = {
	{82, 1},
	{83, 5},
	{0, 4},
};
const static arc arcs_30_5[1] = {
	{14, 6},
};
const static arc arcs_30_6[1] = {
	{15, 7},
};
const static arc arcs_30_7[1] = {
	{0, 7},
};
const static state states_30[8] = {
	{1, (arc*)arcs_30_0, 81, 82, (int*)accel_30_0, 0},
	{1, (arc*)arcs_30_1, 12, 138, (int*)accel_13_4, 0},    /*  optimize! */
	{1, (arc*)arcs_30_2, 14, 15, (int*)accel_30_2, 0},
	{1, (arc*)arcs_30_3, 2, 138, (int*)accel_30_3, 0},
	{3, (arc*)arcs_30_4, 82, 84, (int*)accel_30_4, 1},
	{1, (arc*)arcs_30_5, 14, 15, (int*)accel_30_5, 0},
	{1, (arc*)arcs_30_6, 2, 138, (int*)accel_30_6, 0},
	{1, (arc*)arcs_30_7, 0, 0, 0, 1},
};
const static arc arcs_31_0[1] = {
	{84, 1},
};
const static arc arcs_31_1[1] = {
	{21, 2},
};
const static arc arcs_31_2[1] = {
	{14, 3},
};
const static arc arcs_31_3[1] = {
	{15, 4},
};
const static arc arcs_31_4[2] = {
	{83, 5},
	{0, 4},
};
const static arc arcs_31_5[1] = {
	{14, 6},
};
const static arc arcs_31_6[1] = {
	{15, 7},
};
const static arc arcs_31_7[1] = {
	{0, 7},
};
const static state states_31[8] = {
	{1, (arc*)arcs_31_0, 84, 85, (int*)accel_31_0, 0},
	{1, (arc*)arcs_31_1, 12, 138, (int*)accel_13_4, 0},    /*  optimize! */
	{1, (arc*)arcs_31_2, 14, 15, (int*)accel_31_2, 0},
	{1, (arc*)arcs_31_3, 2, 138, (int*)accel_30_3, 0},    /*  optimize! */
	{2, (arc*)arcs_31_4, 83, 84, (int*)accel_31_4, 1},
	{1, (arc*)arcs_31_5, 14, 15, (int*)accel_31_5, 0},
	{1, (arc*)arcs_31_6, 2, 138, (int*)accel_30_6, 0},    /*  optimize! */
	{1, (arc*)arcs_31_7, 0, 0, 0, 1},
};
const static arc arcs_32_0[1] = {
	{85, 1},
};
const static arc arcs_32_1[1] = {
	{53, 2},
};
const static arc arcs_32_2[1] = {
	{74, 3},
};
const static arc arcs_32_3[1] = {
	{9, 4},
};
const static arc arcs_32_4[1] = {
	{14, 5},
};
const static arc arcs_32_5[1] = {
	{15, 6},
};
const static arc arcs_32_6[2] = {
	{83, 7},
	{0, 6},
};
const static arc arcs_32_7[1] = {
	{14, 8},
};
const static arc arcs_32_8[1] = {
	{15, 9},
};
const static arc arcs_32_9[1] = {
	{0, 9},
};
const static state states_32[10] = {
	{1, (arc*)arcs_32_0, 85, 86, (int*)accel_32_0, 0},
	{1, (arc*)arcs_32_1, 12, 136, (int*)accel_14_1, 0},    /*  optimize! */
	{1, (arc*)arcs_32_2, 74, 75, (int*)accel_32_2, 0},
	{1, (arc*)arcs_32_3, 12, 138, (int*)accel_11_2, 0},    /*  optimize! */
	{1, (arc*)arcs_32_4, 14, 15, (int*)accel_32_4, 0},
	{1, (arc*)arcs_32_5, 2, 138, (int*)accel_32_5, 0},
	{2, (arc*)arcs_32_6, 83, 84, (int*)accel_32_6, 1},
	{1, (arc*)arcs_32_7, 14, 15, (int*)accel_32_7, 0},
	{1, (arc*)arcs_32_8, 2, 138, (int*)accel_32_8, 0},
	{1, (arc*)arcs_32_9, 0, 0, 0, 1},
};
const static arc arcs_33_0[1] = {
	{86, 1},
};
const static arc arcs_33_1[1] = {
	{14, 2},
};
const static arc arcs_33_2[1] = {
	{15, 3},
};
const static arc arcs_33_3[2] = {
	{87, 4},
	{88, 5},
};
const static arc arcs_33_4[1] = {
	{14, 6},
};
const static arc arcs_33_5[1] = {
	{14, 7},
};
const static arc arcs_33_6[1] = {
	{15, 8},
};
const static arc arcs_33_7[1] = {
	{15, 9},
};
const static arc arcs_33_8[3] = {
	{87, 4},
	{83, 5},
	{0, 8},
};
const static arc arcs_33_9[1] = {
	{0, 9},
};
const static state states_33[10] = {
	{1, (arc*)arcs_33_0, 86, 87, (int*)accel_33_0, 0},
	{1, (arc*)arcs_33_1, 14, 15, (int*)accel_33_1, 0},
	{1, (arc*)arcs_33_2, 2, 138, (int*)accel_33_2, 0},
	{2, (arc*)arcs_33_3, 88, 90, (int*)accel_33_3, 0},
	{1, (arc*)arcs_33_4, 14, 15, (int*)accel_33_4, 0},
	{1, (arc*)arcs_33_5, 14, 15, (int*)accel_33_5, 0},
	{1, (arc*)arcs_33_6, 2, 138, (int*)accel_33_6, 0},
	{1, (arc*)arcs_33_7, 2, 138, (int*)accel_32_8, 0},    /*  optimize! */
	{3, (arc*)arcs_33_8, 83, 90, (int*)accel_33_8, 1},
	{1, (arc*)arcs_33_9, 0, 0, 0, 1},
};
const static arc arcs_34_0[1] = {
	{89, 1},
};
const static arc arcs_34_1[2] = {
	{21, 2},
	{0, 1},
};
const static arc arcs_34_2[2] = {
	{22, 3},
	{0, 2},
};
const static arc arcs_34_3[1] = {
	{21, 4},
};
const static arc arcs_34_4[1] = {
	{0, 4},
};
const static state states_34[5] = {
	{1, (arc*)arcs_34_0, 89, 90, (int*)accel_34_0, 0},
	{2, (arc*)arcs_34_1, 12, 138, (int*)accel_13_4, 1},    /*  optimize! */
	{2, (arc*)arcs_34_2, 22, 23, (int*)accel_34_2, 1},
	{1, (arc*)arcs_34_3, 12, 138, (int*)accel_21_3, 0},    /*  optimize! */
	{1, (arc*)arcs_34_4, 0, 0, 0, 1},
};
const static arc arcs_35_0[2] = {
	{3, 1},
	{2, 2},
};
const static arc arcs_35_1[1] = {
	{0, 1},
};
const static arc arcs_35_2[1] = {
	{90, 3},
};
const static arc arcs_35_3[1] = {
	{6, 4},
};
const static arc arcs_35_4[2] = {
	{6, 4},
	{91, 1},
};
const static state states_35[5] = {
	{2, (arc*)arcs_35_0, 2, 138, (int*)accel_35_0, 0},
	{1, (arc*)arcs_35_1, 0, 0, 0, 1},
	{1, (arc*)arcs_35_2, 90, 91, (int*)accel_35_2, 0},
	{1, (arc*)arcs_35_3, 11, 144, (int*)accel_35_3, 0},
	{2, (arc*)arcs_35_4, 11, 144, (int*)accel_35_4, 0},
};
const static arc arcs_36_0[2] = {
	{92, 1},
	{94, 2},
};
const static arc arcs_36_1[2] = {
	{93, 3},
	{0, 1},
};
const static arc arcs_36_2[1] = {
	{0, 2},
};
const static arc arcs_36_3[1] = {
	{92, 1},
};
const static state states_36[4] = {
	{2, (arc*)arcs_36_0, 12, 138, (int*)accel_36_0, 0},
	{2, (arc*)arcs_36_1, 93, 94, (int*)accel_36_1, 1},
	{1, (arc*)arcs_36_2, 0, 0, 0, 1},
	{1, (arc*)arcs_36_3, 12, 136, (int*)accel_36_3, 0},
};
const static arc arcs_37_0[1] = {
	{95, 1},
};
const static arc arcs_37_1[2] = {
	{96, 0},
	{0, 1},
};
const static state states_37[2] = {
	{1, (arc*)arcs_37_0, 12, 136, (int*)accel_37_0, 0},
	{2, (arc*)arcs_37_1, 96, 97, (int*)accel_37_1, 1},
};
const static arc arcs_38_0[2] = {
	{97, 1},
	{98, 2},
};
const static arc arcs_38_1[1] = {
	{95, 2},
};
const static arc arcs_38_2[1] = {
	{0, 2},
};
const static state states_38[3] = {
	{2, (arc*)arcs_38_0, 12, 136, (int*)accel_38_0, 0},
	{1, (arc*)arcs_38_1, 12, 136, (int*)accel_38_1, 0},
	{1, (arc*)arcs_38_2, 0, 0, 0, 1},
};
const static arc arcs_39_0[1] = {
	{73, 1},
};
const static arc arcs_39_1[2] = {
	{99, 0},
	{0, 1},
};
const static state states_39[2] = {
	{1, (arc*)arcs_39_0, 12, 136, (int*)accel_39_0, 0},
	{2, (arc*)arcs_39_1, 74, 108, (int*)accel_39_1, 1},
};
const static arc arcs_40_0[10] = {
	{100, 1},
	{101, 1},
	{102, 1},
	{103, 1},
	{104, 1},
	{105, 1},
	{106, 1},
	{74, 1},
	{97, 2},
	{107, 3},
};
const static arc arcs_40_1[1] = {
	{0, 1},
};
const static arc arcs_40_2[1] = {
	{74, 1},
};
const static arc arcs_40_3[2] = {
	{97, 1},
	{0, 3},
};
const static state states_40[4] = {
	{10, (arc*)arcs_40_0, 74, 108, (int*)accel_40_0, 0},
	{1, (arc*)arcs_40_1, 0, 0, 0, 1},
	{1, (arc*)arcs_40_2, 74, 75, (int*)accel_40_2, 0},
	{2, (arc*)arcs_40_3, 97, 98, (int*)accel_40_3, 1},
};
const static arc arcs_41_0[1] = {
	{108, 1},
};
const static arc arcs_41_1[2] = {
	{109, 0},
	{0, 1},
};
const static state states_41[2] = {
	{1, (arc*)arcs_41_0, 12, 136, (int*)accel_41_0, 0},
	{2, (arc*)arcs_41_1, 109, 110, (int*)accel_41_1, 1},
};
const static arc arcs_42_0[1] = {
	{110, 1},
};
const static arc arcs_42_1[2] = {
	{111, 0},
	{0, 1},
};
const static state states_42[2] = {
	{1, (arc*)arcs_42_0, 12, 136, (int*)accel_42_0, 0},
	{2, (arc*)arcs_42_1, 111, 112, (int*)accel_42_1, 1},
};
const static arc arcs_43_0[1] = {
	{112, 1},
};
const static arc arcs_43_1[2] = {
	{113, 0},
	{0, 1},
};
const static state states_43[2] = {
	{1, (arc*)arcs_43_0, 12, 136, (int*)accel_43_0, 0},
	{2, (arc*)arcs_43_1, 113, 114, (int*)accel_43_1, 1},
};
const static arc arcs_44_0[1] = {
	{114, 1},
};
const static arc arcs_44_1[3] = {
	{115, 0},
	{51, 0},
	{0, 1},
};
const static state states_44[2] = {
	{1, (arc*)arcs_44_0, 12, 136, (int*)accel_44_0, 0},
	{3, (arc*)arcs_44_1, 51, 116, (int*)accel_44_1, 1},
};
const static arc arcs_45_0[1] = {
	{116, 1},
};
const static arc arcs_45_1[3] = {
	{117, 0},
	{118, 0},
	{0, 1},
};
const static state states_45[2] = {
	{1, (arc*)arcs_45_0, 12, 136, (int*)accel_45_0, 0},
	{3, (arc*)arcs_45_1, 117, 119, (int*)accel_45_1, 1},
};
const static arc arcs_46_0[1] = {
	{119, 1},
};
const static arc arcs_46_1[5] = {
	{23, 0},
	{120, 0},
	{121, 0},
	{122, 0},
	{0, 1},
};
const static state states_46[2] = {
	{1, (arc*)arcs_46_0, 12, 136, (int*)accel_46_0, 0},
	{5, (arc*)arcs_46_1, 23, 123, (int*)accel_46_1, 1},
};
const static arc arcs_47_0[4] = {
	{117, 1},
	{118, 1},
	{123, 1},
	{124, 2},
};
const static arc arcs_47_1[1] = {
	{119, 2},
};
const static arc arcs_47_2[1] = {
	{0, 2},
};
const static state states_47[3] = {
	{4, (arc*)arcs_47_0, 12, 136, (int*)accel_47_0, 0},
	{1, (arc*)arcs_47_1, 12, 136, (int*)accel_47_1, 0},
	{1, (arc*)arcs_47_2, 0, 0, 0, 1},
};
const static arc arcs_48_0[1] = {
	{125, 1},
};
const static arc arcs_48_1[3] = {
	{126, 1},
	{24, 2},
	{0, 1},
};
const static arc arcs_48_2[1] = {
	{119, 3},
};
const static arc arcs_48_3[2] = {
	{24, 2},
	{0, 3},
};
const static state states_48[4] = {
	{1, (arc*)arcs_48_0, 12, 136, (int*)accel_48_0, 0},
	{3, (arc*)arcs_48_1, 16, 128, (int*)accel_48_1, 1},
	{1, (arc*)arcs_48_2, 12, 136, (int*)accel_48_2, 0},
	{2, (arc*)arcs_48_3, 24, 25, (int*)accel_48_3, 1},
};
const static arc arcs_49_0[7] = {
	{16, 1},
	{127, 2},
	{130, 3},
	{133, 4},
	{12, 5},
	{134, 5},
	{135, 6},
};
const static arc arcs_49_1[2] = {
	{9, 7},
	{18, 5},
};
const static arc arcs_49_2[2] = {
	{128, 8},
	{129, 5},
};
const static arc arcs_49_3[2] = {
	{131, 9},
	{132, 5},
};
const static arc arcs_49_4[1] = {
	{9, 10},
};
const static arc arcs_49_5[1] = {
	{0, 5},
};
const static arc arcs_49_6[2] = {
	{135, 6},
	{0, 6},
};
const static arc arcs_49_7[1] = {
	{18, 5},
};
const static arc arcs_49_8[1] = {
	{129, 5},
};
const static arc arcs_49_9[1] = {
	{132, 5},
};
const static arc arcs_49_10[1] = {
	{133, 5},
};
const static state states_49[11] = {
	{7, (arc*)arcs_49_0, 12, 136, (int*)accel_49_0, 0},
	{2, (arc*)arcs_49_1, 12, 138, (int*)accel_49_1, 0},
	{2, (arc*)arcs_49_2, 12, 138, (int*)accel_49_2, 0},
	{2, (arc*)arcs_49_3, 12, 138, (int*)accel_49_3, 0},
	{1, (arc*)arcs_49_4, 12, 138, (int*)accel_49_4, 0},
	{1, (arc*)arcs_49_5, 0, 0, 0, 1},
	{2, (arc*)arcs_49_6, 135, 136, (int*)accel_49_6, 1},
	{1, (arc*)arcs_49_7, 18, 19, (int*)accel_49_7, 0},
	{1, (arc*)arcs_49_8, 129, 130, (int*)accel_49_8, 0},
	{1, (arc*)arcs_49_9, 132, 133, (int*)accel_49_9, 0},
	{1, (arc*)arcs_49_10, 133, 134, (int*)accel_49_10, 0},
};
const static arc arcs_50_0[1] = {
	{21, 1},
};
const static arc arcs_50_1[3] = {
	{136, 2},
	{22, 3},
	{0, 1},
};
const static arc arcs_50_2[1] = {
	{0, 2},
};
const static arc arcs_50_3[2] = {
	{21, 4},
	{0, 3},
};
const static arc arcs_50_4[2] = {
	{22, 3},
	{0, 4},
};
const static state states_50[5] = {
	{1, (arc*)arcs_50_0, 12, 138, (int*)accel_50_0, 0},
	{3, (arc*)arcs_50_1, 22, 86, (int*)accel_50_1, 1},
	{1, (arc*)arcs_50_2, 0, 0, 0, 1},
	{2, (arc*)arcs_50_3, 12, 138, (int*)accel_21_3, 1},    /*  optimize! */
	{2, (arc*)arcs_50_4, 22, 23, (int*)accel_50_4, 1},
};
const static arc arcs_51_0[1] = {
	{137, 1},
};
const static arc arcs_51_1[2] = {
	{17, 2},
	{14, 3},
};
const static arc arcs_51_2[1] = {
	{14, 3},
};
const static arc arcs_51_3[1] = {
	{21, 4},
};
const static arc arcs_51_4[1] = {
	{0, 4},
};
const static state states_51[5] = {
	{1, (arc*)arcs_51_0, 137, 138, (int*)accel_51_0, 0},
	{2, (arc*)arcs_51_1, 12, 25, (int*)accel_51_1, 0},
	{1, (arc*)arcs_51_2, 14, 15, (int*)accel_51_2, 0},
	{1, (arc*)arcs_51_3, 12, 138, (int*)accel_21_3, 0},    /*  optimize! */
	{1, (arc*)arcs_51_4, 0, 0, 0, 1},
};
const static arc arcs_52_0[3] = {
	{16, 1},
	{127, 2},
	{70, 3},
};
const static arc arcs_52_1[2] = {
	{138, 4},
	{18, 5},
};
const static arc arcs_52_2[1] = {
	{139, 6},
};
const static arc arcs_52_3[1] = {
	{12, 5},
};
const static arc arcs_52_4[1] = {
	{18, 5},
};
const static arc arcs_52_5[1] = {
	{0, 5},
};
const static arc arcs_52_6[1] = {
	{129, 5},
};
const static state states_52[7] = {
	{3, (arc*)arcs_52_0, 16, 128, (int*)accel_52_0, 0},
	{2, (arc*)arcs_52_1, 12, 138, (int*)accel_52_1, 0},
	{1, (arc*)arcs_52_2, 12, 138, (int*)accel_52_2, 0},
	{1, (arc*)arcs_52_3, 12, 13, (int*)accel_52_3, 0},
	{1, (arc*)arcs_52_4, 18, 19, (int*)accel_52_4, 0},
	{1, (arc*)arcs_52_5, 0, 0, 0, 1},
	{1, (arc*)arcs_52_6, 129, 130, (int*)accel_52_6, 0},
};
const static arc arcs_53_0[1] = {
	{140, 1},
};
const static arc arcs_53_1[2] = {
	{22, 2},
	{0, 1},
};
const static arc arcs_53_2[2] = {
	{140, 1},
	{0, 2},
};
const static state states_53[3] = {
	{1, (arc*)arcs_53_0, 12, 138, (int*)accel_53_0, 0},
	{2, (arc*)arcs_53_1, 22, 23, (int*)accel_53_1, 1},
	{2, (arc*)arcs_53_2, 12, 138, (int*)accel_53_0, 1},    /*  optimize! */
};
const static arc arcs_54_0[3] = {
	{70, 1},
	{21, 2},
	{14, 3},
};
const static arc arcs_54_1[1] = {
	{70, 4},
};
const static arc arcs_54_2[2] = {
	{14, 3},
	{0, 2},
};
const static arc arcs_54_3[3] = {
	{21, 5},
	{141, 6},
	{0, 3},
};
const static arc arcs_54_4[1] = {
	{70, 6},
};
const static arc arcs_54_5[2] = {
	{141, 6},
	{0, 5},
};
const static arc arcs_54_6[1] = {
	{0, 6},
};
const static state states_54[7] = {
	{3, (arc*)arcs_54_0, 12, 138, (int*)accel_54_0, 0},
	{1, (arc*)arcs_54_1, 70, 71, (int*)accel_54_1, 0},
	{2, (arc*)arcs_54_2, 14, 15, (int*)accel_54_2, 1},
	{3, (arc*)arcs_54_3, 12, 138, (int*)accel_54_3, 1},
	{1, (arc*)arcs_54_4, 70, 71, (int*)accel_54_4, 0},
	{2, (arc*)arcs_54_5, 14, 15, (int*)accel_54_5, 1},
	{1, (arc*)arcs_54_6, 0, 0, 0, 1},
};
const static arc arcs_55_0[1] = {
	{14, 1},
};
const static arc arcs_55_1[2] = {
	{21, 2},
	{0, 1},
};
const static arc arcs_55_2[1] = {
	{0, 2},
};
const static state states_55[3] = {
	{1, (arc*)arcs_55_0, 14, 15, (int*)accel_55_0, 0},
	{2, (arc*)arcs_55_1, 12, 138, (int*)accel_13_4, 1},    /*  optimize! */
	{1, (arc*)arcs_55_2, 0, 0, 0, 1},
};
const static arc arcs_56_0[1] = {
	{73, 1},
};
const static arc arcs_56_1[2] = {
	{22, 2},
	{0, 1},
};
const static arc arcs_56_2[2] = {
	{73, 1},
	{0, 2},
};
const static state states_56[3] = {
	{1, (arc*)arcs_56_0, 12, 136, (int*)accel_39_0, 0},    /*  optimize! */
	{2, (arc*)arcs_56_1, 22, 23, (int*)accel_56_1, 1},
	{2, (arc*)arcs_56_2, 12, 136, (int*)accel_39_0, 1},    /*  optimize! */
};
const static arc arcs_57_0[1] = {
	{21, 1},
};
const static arc arcs_57_1[2] = {
	{22, 2},
	{0, 1},
};
const static arc arcs_57_2[2] = {
	{21, 1},
	{0, 2},
};
const static state states_57[3] = {
	{1, (arc*)arcs_57_0, 12, 138, (int*)accel_50_0, 0},    /*  optimize! */
	{2, (arc*)arcs_57_1, 22, 23, (int*)accel_57_1, 1},
	{2, (arc*)arcs_57_2, 12, 138, (int*)accel_50_0, 1},    /*  optimize! */
};
const static arc arcs_58_0[1] = {
	{21, 1},
};
const static arc arcs_58_1[2] = {
	{22, 2},
	{0, 1},
};
const static arc arcs_58_2[1] = {
	{21, 3},
};
const static arc arcs_58_3[2] = {
	{22, 4},
	{0, 3},
};
const static arc arcs_58_4[2] = {
	{21, 3},
	{0, 4},
};
const static state states_58[5] = {
	{1, (arc*)arcs_58_0, 12, 138, (int*)accel_50_0, 0},    /*  optimize! */
	{2, (arc*)arcs_58_1, 22, 23, (int*)accel_58_1, 1},
	{1, (arc*)arcs_58_2, 12, 138, (int*)accel_58_2, 0},
	{2, (arc*)arcs_58_3, 22, 23, (int*)accel_58_3, 1},
	{2, (arc*)arcs_58_4, 12, 138, (int*)accel_58_2, 1},    /*  optimize! */
};
const static arc arcs_59_0[1] = {
	{21, 1},
};
const static arc arcs_59_1[1] = {
	{14, 2},
};
const static arc arcs_59_2[1] = {
	{21, 3},
};
const static arc arcs_59_3[2] = {
	{22, 4},
	{0, 3},
};
const static arc arcs_59_4[2] = {
	{21, 1},
	{0, 4},
};
const static state states_59[5] = {
	{1, (arc*)arcs_59_0, 12, 138, (int*)accel_50_0, 0},    /*  optimize! */
	{1, (arc*)arcs_59_1, 14, 15, (int*)accel_59_1, 0},
	{1, (arc*)arcs_59_2, 12, 138, (int*)accel_58_2, 0},    /*  optimize! */
	{2, (arc*)arcs_59_3, 22, 23, (int*)accel_59_3, 1},
	{2, (arc*)arcs_59_4, 12, 138, (int*)accel_50_0, 1},    /*  optimize! */
};
const static arc arcs_60_0[1] = {
	{143, 1},
};
const static arc arcs_60_1[1] = {
	{12, 2},
};
const static arc arcs_60_2[2] = {
	{16, 3},
	{14, 4},
};
const static arc arcs_60_3[1] = {
	{9, 5},
};
const static arc arcs_60_4[1] = {
	{15, 6},
};
const static arc arcs_60_5[1] = {
	{18, 7},
};
const static arc arcs_60_6[1] = {
	{0, 6},
};
const static arc arcs_60_7[1] = {
	{14, 4},
};
const static state states_60[8] = {
	{1, (arc*)arcs_60_0, 143, 144, (int*)accel_60_0, 0},
	{1, (arc*)arcs_60_1, 12, 13, (int*)accel_60_1, 0},
	{2, (arc*)arcs_60_2, 14, 17, (int*)accel_60_2, 0},
	{1, (arc*)arcs_60_3, 12, 138, (int*)accel_11_3, 0},    /*  optimize! */
	{1, (arc*)arcs_60_4, 2, 138, (int*)accel_32_5, 0},    /*  optimize! */
	{1, (arc*)arcs_60_5, 18, 19, (int*)accel_60_5, 0},
	{1, (arc*)arcs_60_6, 0, 0, 0, 1},
	{1, (arc*)arcs_60_7, 14, 15, (int*)accel_60_7, 0},
};
const static arc arcs_61_0[3] = {
	{144, 1},
	{23, 2},
	{24, 3},
};
const static arc arcs_61_1[2] = {
	{22, 4},
	{0, 1},
};
const static arc arcs_61_2[1] = {
	{21, 5},
};
const static arc arcs_61_3[1] = {
	{21, 6},
};
const static arc arcs_61_4[4] = {
	{144, 1},
	{23, 2},
	{24, 3},
	{0, 4},
};
const static arc arcs_61_5[2] = {
	{22, 7},
	{0, 5},
};
const static arc arcs_61_6[1] = {
	{0, 6},
};
const static arc arcs_61_7[1] = {
	{24, 3},
};
const static state states_61[8] = {
	{3, (arc*)arcs_61_0, 12, 138, (int*)accel_61_0, 0},
	{2, (arc*)arcs_61_1, 22, 23, (int*)accel_61_1, 1},
	{1, (arc*)arcs_61_2, 12, 138, (int*)accel_13_3, 0},    /*  optimize! */
	{1, (arc*)arcs_61_3, 12, 138, (int*)accel_21_5, 0},    /*  optimize! */
	{4, (arc*)arcs_61_4, 12, 138, (int*)accel_61_0, 1},    /*  optimize! */
	{2, (arc*)arcs_61_5, 22, 23, (int*)accel_61_5, 1},
	{1, (arc*)arcs_61_6, 0, 0, 0, 1},
	{1, (arc*)arcs_61_7, 24, 25, (int*)accel_61_7, 0},
};
const static arc arcs_62_0[1] = {
	{21, 1},
};
const static arc arcs_62_1[2] = {
	{20, 2},
	{0, 1},
};
const static arc arcs_62_2[1] = {
	{21, 3},
};
const static arc arcs_62_3[1] = {
	{0, 3},
};
const static state states_62[4] = {
	{1, (arc*)arcs_62_0, 12, 138, (int*)accel_50_0, 0},    /*  optimize! */
	{2, (arc*)arcs_62_1, 20, 21, (int*)accel_62_1, 1},
	{1, (arc*)arcs_62_2, 12, 138, (int*)accel_58_2, 0},    /*  optimize! */
	{1, (arc*)arcs_62_3, 0, 0, 0, 1},
};
const static arc arcs_63_0[2] = {
	{136, 1},
	{146, 1},
};
const static arc arcs_63_1[1] = {
	{0, 1},
};
const static state states_63[2] = {
	{2, (arc*)arcs_63_0, 81, 86, (int*)accel_63_0, 0},
	{1, (arc*)arcs_63_1, 0, 0, 0, 1},
};
const static arc arcs_64_0[1] = {
	{85, 1},
};
const static arc arcs_64_1[1] = {
	{53, 2},
};
const static arc arcs_64_2[1] = {
	{74, 3},
};
const static arc arcs_64_3[1] = {
	{142, 4},
};
const static arc arcs_64_4[2] = {
	{145, 5},
	{0, 4},
};
const static arc arcs_64_5[1] = {
	{0, 5},
};
const static state states_64[6] = {
	{1, (arc*)arcs_64_0, 85, 86, (int*)accel_64_0, 0},
	{1, (arc*)arcs_64_1, 12, 136, (int*)accel_14_1, 0},    /*  optimize! */
	{1, (arc*)arcs_64_2, 74, 75, (int*)accel_64_2, 0},
	{1, (arc*)arcs_64_3, 12, 138, (int*)accel_64_3, 0},
	{2, (arc*)arcs_64_4, 81, 86, (int*)accel_64_4, 1},
	{1, (arc*)arcs_64_5, 0, 0, 0, 1},
};
const static arc arcs_65_0[1] = {
	{81, 1},
};
const static arc arcs_65_1[1] = {
	{21, 2},
};
const static arc arcs_65_2[2] = {
	{145, 3},
	{0, 2},
};
const static arc arcs_65_3[1] = {
	{0, 3},
};
const static state states_65[4] = {
	{1, (arc*)arcs_65_0, 81, 82, (int*)accel_65_0, 0},
	{1, (arc*)arcs_65_1, 12, 138, (int*)accel_13_4, 0},    /*  optimize! */
	{2, (arc*)arcs_65_2, 81, 86, (int*)accel_65_2, 1},
	{1, (arc*)arcs_65_3, 0, 0, 0, 1},
};
const static dfa dfas[66] = {
	{256, "single_input", 0, 3, (state*)states_0,
	 "\004\030\001\000\000\000\124\360\213\011\162\000\002\000\140\210\344\202\000"},
	{257, "file_input", 0, 2, (state*)states_1,
	 "\204\030\001\000\000\000\124\360\213\011\162\000\002\000\140\210\344\202\000"},
	{258, "eval_input", 0, 3, (state*)states_2,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{259, "funcdef", 0, 6, (state*)states_3,
	 "\000\010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{260, "parameters", 0, 4, (state*)states_4,
	 "\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{261, "varargslist", 0, 10, (state*)states_5,
	 "\000\020\201\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{262, "fpdef", 0, 4, (state*)states_6,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{263, "fplist", 0, 3, (state*)states_7,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{264, "stmt", 0, 2, (state*)states_8,
	 "\000\030\001\000\000\000\124\360\213\011\162\000\002\000\140\210\344\202\000"},
	{265, "simple_stmt", 0, 4, (state*)states_9,
	 "\000\020\001\000\000\000\124\360\213\011\000\000\002\000\140\210\344\002\000"},
	{266, "small_stmt", 0, 2, (state*)states_10,
	 "\000\020\001\000\000\000\124\360\213\011\000\000\002\000\140\210\344\002\000"},
	{267, "expr_stmt", 0, 6, (state*)states_11,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{268, "augassign", 0, 2, (state*)states_12,
	 "\000\000\000\000\300\377\003\000\000\000\000\000\000\000\000\000\000\000\000"},
	{269, "print_stmt", 0, 9, (state*)states_13,
	 "\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000"},
	{270, "del_stmt", 0, 3, (state*)states_14,
	 "\000\000\000\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000"},
	{271, "pass_stmt", 0, 2, (state*)states_15,
	 "\000\000\000\000\000\000\100\000\000\000\000\000\000\000\000\000\000\000\000"},
	{272, "flow_stmt", 0, 2, (state*)states_16,
	 "\000\000\000\000\000\000\000\360\001\000\000\000\000\000\000\000\000\000\000"},
	{273, "break_stmt", 0, 2, (state*)states_17,
	 "\000\000\000\000\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000"},
	{274, "continue_stmt", 0, 2, (state*)states_18,
	 "\000\000\000\000\000\000\000\040\000\000\000\000\000\000\000\000\000\000\000"},
	{275, "return_stmt", 0, 3, (state*)states_19,
	 "\000\000\000\000\000\000\000\100\000\000\000\000\000\000\000\000\000\000\000"},
	{276, "yield_stmt", 0, 3, (state*)states_20,
	 "\000\000\000\000\000\000\000\200\000\000\000\000\000\000\000\000\000\000\000"},
	{277, "raise_stmt", 0, 7, (state*)states_21,
	 "\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000"},
	{278, "import_stmt", 0, 9, (state*)states_22,
	 "\000\000\000\000\000\000\000\000\012\000\000\000\000\000\000\000\000\000\000"},
	{279, "import_as_name", 0, 4, (state*)states_23,
	 "\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{280, "dotted_as_name", 0, 4, (state*)states_24,
	 "\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{281, "dotted_name", 0, 2, (state*)states_25,
	 "\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{282, "global_stmt", 0, 3, (state*)states_26,
	 "\000\000\000\000\000\000\000\000\200\000\000\000\000\000\000\000\000\000\000"},
	{283, "exec_stmt", 0, 7, (state*)states_27,
	 "\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000"},
	{284, "assert_stmt", 0, 5, (state*)states_28,
	 "\000\000\000\000\000\000\000\000\000\010\000\000\000\000\000\000\000\000\000"},
	{285, "compound_stmt", 0, 2, (state*)states_29,
	 "\000\010\000\000\000\000\000\000\000\000\162\000\000\000\000\000\000\200\000"},
	{286, "if_stmt", 0, 8, (state*)states_30,
	 "\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000"},
	{287, "while_stmt", 0, 8, (state*)states_31,
	 "\000\000\000\000\000\000\000\000\000\000\020\000\000\000\000\000\000\000\000"},
	{288, "for_stmt", 0, 10, (state*)states_32,
	 "\000\000\000\000\000\000\000\000\000\000\040\000\000\000\000\000\000\000\000"},
	{289, "try_stmt", 0, 10, (state*)states_33,
	 "\000\000\000\000\000\000\000\000\000\000\100\000\000\000\000\000\000\000\000"},
	{290, "except_clause", 0, 5, (state*)states_34,
	 "\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000"},
	{291, "suite", 0, 5, (state*)states_35,
	 "\004\020\001\000\000\000\124\360\213\011\000\000\002\000\140\210\344\002\000"},
	{292, "test", 0, 4, (state*)states_36,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{293, "and_test", 0, 2, (state*)states_37,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\000\000"},
	{294, "not_test", 0, 3, (state*)states_38,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\000\000"},
	{295, "comparison", 0, 2, (state*)states_39,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{296, "comp_op", 0, 4, (state*)states_40,
	 "\000\000\000\000\000\000\000\000\000\004\000\000\362\017\000\000\000\000\000"},
	{297, "expr", 0, 2, (state*)states_41,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{298, "xor_expr", 0, 2, (state*)states_42,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{299, "and_expr", 0, 2, (state*)states_43,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{300, "shift_expr", 0, 2, (state*)states_44,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{301, "arith_expr", 0, 2, (state*)states_45,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{302, "term", 0, 2, (state*)states_46,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{303, "factor", 0, 3, (state*)states_47,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{304, "power", 0, 4, (state*)states_48,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\000\200\344\000\000"},
	{305, "atom", 0, 11, (state*)states_49,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\000\200\344\000\000"},
	{306, "listmaker", 0, 5, (state*)states_50,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{307, "lambdef", 0, 5, (state*)states_51,
	 "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000"},
	{308, "trailer", 0, 7, (state*)states_52,
	 "\000\000\001\000\000\000\000\000\100\000\000\000\000\000\000\200\000\000\000"},
	{309, "subscriptlist", 0, 3, (state*)states_53,
	 "\000\120\001\000\000\000\000\000\100\000\000\000\002\000\140\210\344\002\000"},
	{310, "subscript", 0, 7, (state*)states_54,
	 "\000\120\001\000\000\000\000\000\100\000\000\000\002\000\140\210\344\002\000"},
	{311, "sliceop", 0, 3, (state*)states_55,
	 "\000\100\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000"},
	{312, "exprlist", 0, 3, (state*)states_56,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\000\000\140\210\344\000\000"},
	{313, "testlist", 0, 3, (state*)states_57,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{314, "testlist_safe", 0, 5, (state*)states_58,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{315, "dictmaker", 0, 5, (state*)states_59,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{316, "classdef", 0, 8, (state*)states_60,
	 "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\200\000"},
	{317, "arglist", 0, 8, (state*)states_61,
	 "\000\020\201\001\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{318, "argument", 0, 4, (state*)states_62,
	 "\000\020\001\000\000\000\000\000\000\000\000\000\002\000\140\210\344\002\000"},
	{319, "list_iter", 0, 2, (state*)states_63,
	 "\000\000\000\000\000\000\000\000\000\000\042\000\000\000\000\000\000\000\000"},
	{320, "list_for", 0, 6, (state*)states_64,
	 "\000\000\000\000\000\000\000\000\000\000\040\000\000\000\000\000\000\000\000"},
	{321, "list_if", 0, 4, (state*)states_65,
	 "\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000"},
};
const static label labels[147] = {
	{0, "EMPTY"},
	{256, 0},
	{4, 0},
	{265, 0},
	{285, 0},
	{257, 0},
	{264, 0},
	{0, 0},
	{258, 0},
	{313, 0},
	{259, 0},
	{1, "def"},
	{1, 0},
	{260, 0},
	{11, 0},
	{291, 0},
	{7, 0},
	{261, 0},
	{8, 0},
	{262, 0},
	{22, 0},
	{292, 0},
	{12, 0},
	{16, 0},
	{36, 0},
	{263, 0},
	{266, 0},
	{13, 0},
	{267, 0},
	{269, 0},
	{270, 0},
	{271, 0},
	{272, 0},
	{278, 0},
	{282, 0},
	{283, 0},
	{284, 0},
	{268, 0},
	{37, 0},
	{38, 0},
	{39, 0},
	{40, 0},
	{41, 0},
	{42, 0},
	{43, 0},
	{44, 0},
	{45, 0},
	{46, 0},
	{47, 0},
	{49, 0},
	{1, "print"},
	{35, 0},
	{1, "del"},
	{312, 0},
	{1, "pass"},
	{273, 0},
	{274, 0},
	{275, 0},
	{277, 0},
	{276, 0},
	{1, "break"},
	{1, "continue"},
	{1, "return"},
	{1, "yield"},
	{1, "raise"},
	{1, "import"},
	{280, 0},
	{1, "from"},
	{281, 0},
	{279, 0},
	{23, 0},
	{1, "global"},
	{1, "exec"},
	{297, 0},
	{1, "in"},
	{1, "assert"},
	{286, 0},
	{287, 0},
	{288, 0},
	{289, 0},
	{316, 0},
	{1, "if"},
	{1, "elif"},
	{1, "else"},
	{1, "while"},
	{1, "for"},
	{1, "try"},
	{290, 0},
	{1, "finally"},
	{1, "except"},
	{5, 0},
	{6, 0},
	{293, 0},
	{1, "or"},
	{307, 0},
	{294, 0},
	{1, "and"},
	{1, "not"},
	{295, 0},
	{296, 0},
	{20, 0},
	{21, 0},
	{28, 0},
	{31, 0},
	{30, 0},
	{29, 0},
	{29, 0},
	{1, "is"},
	{298, 0},
	{18, 0},
	{299, 0},
	{33, 0},
	{300, 0},
	{19, 0},
	{301, 0},
	{34, 0},
	{302, 0},
	{14, 0},
	{15, 0},
	{303, 0},
	{17, 0},
	{24, 0},
	{48, 0},
	{32, 0},
	{304, 0},
	{305, 0},
	{308, 0},
	{9, 0},
	{306, 0},
	{10, 0},
	{26, 0},
	{315, 0},
	{27, 0},
	{25, 0},
	{2, 0},
	{3, 0},
	{320, 0},
	{1, "lambda"},
	{317, 0},
	{309, 0},
	{310, 0},
	{311, 0},
	{314, 0},
	{1, "class"},
	{318, 0},
	{319, 0},
	{321, 0},
};
const grammar _PyParser_Grammar = {
	66,
	(dfa*)dfas,
	{147, (label*)labels},
	256,
	1,
};





























































